#!/usr/bin/php -q
<?php
ini_set("error_reporting", "E_ERROR");
ini_set("soap.wsdl_cache_enabled","0");
ini_set('magic_quotes_gpc', 'off');
ini_set('register_globals', 'off');
ini_set('max_execution_time', 300);
ini_set("display_errors", 1);
date_default_timezone_set('America/Chicago');

function log_print_text($str) {						// a couple of simple routines to write debug info to log file
	global $logfilen;
	global $loglevel;
	if($loglevel >=3){$logfile = fopen($logfilen, 'a');} else {$logfile = fopen($logfilen, 'w');}
	fputs($logfile, "\r\n$str");
	fclose($logfile);
}

function log_var_dump($v_array) {
	global $logfilen;
	global $loglevel;
	if($loglevel >=3){$logfile = fopen($logfilen, 'a');} else {$logfile = fopen($logfilen, 'w');}
   ob_start();
   var_dump($v_array);
   $out = ob_get_contents();
   ob_end_clean();
   fputs($logfile, "\r\n$out");
	fclose($logfile);   	
}

require_once('config.php');							// config has location for log files and loglevel
require_once('php-sip/PhpSIP.class.php');			// great system to generate SIP control messages

$polycompath = '/home/polycom/'; 					// location of Polycom config files on this server
$sipserver   = '10.10.1.80';							// default address of this server in not available in $_SERVER 

if (isset($_SERVER['argv'])) {						// assuming command line call.  First argument is program name
   $args = $_SERVER['argv'];
   if (isset($args[0])) {$arg0 = $args[0];} else {$arg0 = 'generic.php';}
   if (isset($args[1])) {$arg1 = $args[1];} else {$arg1 = '1003';}	// default in case no argument is passed.  Maybe an error message is in order
}
$sip_to = $arg1;											// just to keep it clean
$sip_from = 'asterisk';									// default name of this server

if (isset($_SERVER['SERVER_ADDR'])) {$server_ip = $_SERVER['SERVER_ADDR'];} else {$server_ip = $sipserver;}	// will always fail in command mode
$tim1 = time();											// unix timestamp
$date_log = date('mdY', $tim1);						// format for log file name
$fn = basename($arg0, '.php');						// get base name of this file
$logfilen = $logdir . strtolower($fn) . '-' . $date_log . '.log';		// form log filename with date
$msg = "\nStarting: $arg0";								// log the startup
log_print_text($msg);
echo "$msg\r\n";
$msg = "Logging to: $logfilen from server: $server_ip";
log_print_text($msg);
echo "$msg\r\n";
log_var_dump($_SERVER['argv']);						// dump the argv list for debug

$dirfiles = scandir($polycompath, 0);				// get the filesname in the polycom directory
$configs = array();
foreach ($dirfiles as $value) {						// loop through all the names saving only what we need
	$t1 = stripos($value, '.cfg');					// must be a .cfg file
	if($t1 !== false){									// if it is, then further qualify it
		$t1 = stripos($value, '0004f2'); 			// beginning mac address values for the polycom phones
		$t2 = stripos($value, 'phone'); 				// forget any user generated configs
		$t3 = stripos($value, 'web'); 				// forget any web generated configs
		if (($t1 !== false) and ($t2 === false) and ($t3 === false)){
			$configs[] = $polycompath . $value;		// save a good config file
		}		
	}	
}
if($loglevel >=4){log_var_dump($configs);}

$found_ext_file = '';
foreach ($configs as $value) {
	$xml = simplexml_load_file($value);				// load in the config file and parse as XML
	$cf = $xml->attributes()->CONFIG_FILES;		// pull out the referenced config files
	$cf_a = explode(',', $cf);							// expand the list into an array
	foreach ($cf_a as $fn) {
		$t1 = stripos($fn, 'phone-vl'); 				// the particular phone prefix to check for.  Probably different in each system!!
		if ($t1 !== false){
			if($loglevel >=4){log_print_text($fn);}
			$fn = $polycompath . $fn;					// save the full address
			$xmlphone = simplexml_load_file($fn);	// load this config file and parse as XML
			if($loglevel >=5){log_var_dump($xmlphone);}
			$reg = $xmlphone->reg->attributes();	// get the reg line
			$lc = 1;
			foreach($reg as $a => $b) {  				// loop thru all registration addresses in the file and check for an extension match.
				$t = 'reg.' . $lc . '.address';
				if($a == $t){								// this line is a registration address
					if($loglevel >=4){
						$msg = $t . '=' . $b . "\r\n"; 	// output as a test
						log_print_text($msg);
						echo "$msg\r\n";
					}
					$lc++;									// step to next registration
					if($b == $sip_to){ 					// if a match, then requested extension is a valid one on this server
						$found_ext_file = $fn;			// save phone configuration file name
						$found_base = $value;			// save base configuration file name
						break;								// break out of the registration loop
					}
				}
			}
		}
	}
	if($found_ext_file != ''){break;}				// if found it break out of config file search loop
}
$msg = "Found file: $found_ext_file";
log_print_text($msg);
echo "$msg\r\n";	

$msg = "Found base file: $found_base";
log_print_text($msg);
echo "$msg\r\n";	

$bn = basename($found_base, '.cfg');				// get mac address from config file name
$ebn = substr($bn, 0, 2) . ':' . substr($bn, 2, 2) . ':' .substr($bn, 4, 2) . ':' .substr($bn, 6, 2) . ':' .substr($bn, 8, 2) . ':' .substr($bn, 10, 2);
$msg = "Findind IP address for Mac Address: $ebn";
log_print_text($msg);
echo "$msg\r\n";	

$command = 'arp -a';										// this system lists the present arp table.
$arp = shell_exec($command);							// shell_exec returns the entire output
$msg = "\nArp Table is as follows:";
log_print_text($msg);
log_print_text($arp);

$lines = explode("\n", $arp);							// expand each line into an array
foreach ($lines as $value) { 							// loop through, looking for our desired mac address
	$t1 = stripos($value, $ebn);
	if ($t1 !== false){ 									// if found, extract the ip address
		$t2 = stripos($value, '(');
		$t3 = stripos($value, ')');
		$t2++;
		$ip = substr($value, $t2, ($t3 - $t2));
		break;			
	}
}
$msg = "IP address for $ebn is $ip";
log_print_text($msg);
echo "$msg\r\n";
$good_date = date('D, d M o h:m:s T', $tim1);	// just form a nice date for the logs
$msg = "Sending Event: check-sync at $good_date";
log_print_text($msg);
echo "$msg\r\n";

try {  														// send the phone the message using the nice PhpSIP class system!!
	$api = new PhpSIP($server_ip);					// bind to IP of this server
	$api->setDebug(true);	
//	$api->setUsername('10000');						// authentication username if required
//	$api->setPassword('secret');						// authentication password if required
//	$api->setProxy('some_ip_here');					// proxy if required 
	$api->addHeader('Event: check-sync'); 			// what Polycom phones nead to hear
	$api->setMethod('NOTIFY');
	$api->setFrom("sip:$sip_from@$server_ip");	// generic header, in this case, sip:asterisk@10.1.1.80
	$api->setUri("sip:$sip_to@$ip");					// Example: ext: 101 and IP address 10.1.1.101 Then: sip:101@10.1.1.101
	$res = $api->send();
	$msg = "res1: $res";									// just print out response 
	log_print_text($msg);
	echo "$msg\r\n";	 
} 
catch (Exception $e) { 
	echo $e->getMessage()."\n"; 						// print out error message, just in case
}
?>