<?php
ini_set("error_reporting", "E_ERROR");
ini_set("soap.wsdl_cache_enabled","0");
ini_set('magic_quotes_gpc', 'off');
ini_set('register_globals', 'off');
ini_set('max_execution_time', 300);
ini_set("display_errors", 1);
date_default_timezone_set('America/Chicago');

function log_print_text($str) {
	global $logfilen;
	global $loglevel;
	global $new_script;
	if($loglevel >= 3 or !$new_script){$logfile = fopen($logfilen, 'a');} else {$logfile = fopen($logfilen, 'w');}
	fputs($logfile, "\r\n$str");
	fclose($logfile);
	$new_script = false;
}

function log_var_dump($v_array) {
	global $logfilen;
	global $loglevel;
	global $new_script;
	if($loglevel >= 3 or !$new_script){$logfile = fopen($logfilen, 'a');} else {$logfile = fopen($logfilen, 'w');}
   ob_start();
   var_dump($v_array);
   $out = ob_get_contents();
   ob_end_clean();
   fputs($logfile, "\r\n$out");
	fclose($logfile);   	
	$new_script = false;
}

function get_log_name() {
	global $_SERVER;
	global $logdir;
	$default = 'generic.php';
	if (isset($_SERVER['argv'])) {													// Start by assuming command line call.  First argument is program name
	   $args = $_SERVER['argv'];                                         	
	   if (isset($args[0])) {$arg0 = $args[0];} else {$arg0 = $default;}	// If argv is present but no name assign a generiv name.
	   if (isset($args[1])) {$arg1 = $args[1];} else {$arg1 = '1003';}	// default in case no argument is passed.  Maybe an error message is in order
	}
	else if (isset($_SERVER['REQUEST_URI'])) {									// If a server call, get the script name called.
		$arg0 = $_SERVER['REQUEST_URI'];
	}
	else {
		$arg0 = $default;																	// No other choice
	}	
	$tim1 = time();																		// Unix timestamp
	$date_log = date('mdY', $tim1);													// format for log file name
	$fn = basename($arg0, '.php');													// get base name of this file
	$logfilen = $logdir . strtolower($fn) . '-' . $date_log . '.log';		// form log filename with date
	return $logfilen;	
}

function fix_phone($text) {
   $trans = array("(" => "", ")" => "", " " => "", "." => "", "-" => "" );
   $text = trim($text);
   $text = strtr( $text, $trans);
   return $text;      
}
	
$path = '/usr/share/pear/log4php';    												// Needed by PAMI libraries
set_include_path(get_include_path() . PATH_SEPARATOR . $path);				// in case it was not in include path

require_once 'config.php';																// config has location for log files and loglevel
require_once './SOAP/nusoap.php';													// nusoap library makes it very simple to write a web service
require_once './phpagi/phpagi-asmanager.php';									// use this to interface to Asterisk Manager Interface (AMI)
																								// an alternative to PAMI as used in other programs

$default_ip = '192.168.1.80'; 														// IP address needed for local test send
																								// Extract from $_SERVER variables if present
																								// otherwise use default IP address entered here.
if (isset($_SERVER['SERVER_ADDR'])) {$serverip = $_SERVER['SERVER_ADDR'];}  else {$serverip = $default_ip;}
$logfilen = get_log_name(); 															// Get log file name from this script name
$new_script = true;																		// First time so open a new file if not appending because of log level

$namespace = "http://phones.domain.com:8080/sms/sms-ws.php?wsdl";			// This servers FQDN and script name.  Set as required for your install
$server = new soap_server;
$server->configureWSDL("sms-ws");
$server->wsdl->schemaTargetNamespace = $namespace;

$server->wsdl->addComplexType(  														// Set up variable types. This is more or less a dummy to test the SOAP transactions
   'InfoReq', 'complexType', 'struct', 'all', '',
   array(
      'extension' => array('name' => 'extension', 'type' => 'xsd:string')
   )
);

$server->wsdl->addComplexType(
   'InfoResp', 'complexType', 'struct', 'all', '',
   array(
      'status' => array('name' => 'status', 'type' => 'xsd:string'),
      'message' => array('name' => 'message', 'type' => 'xsd:string')
   )
);

$server->wsdl->addComplexType( 														// Set up the variables for the text send web service
   'TextSend', 'complexType', 'struct', 'all', '',
   array(
      'extension' => array('name' => 'extension', 'type' => 'xsd:string'),
      'from' => array('name' => 'from', 'type' => 'xsd:string'),
      'body' => array('name' => 'body', 'type' => 'xsd:string')
   )
);

$server->wsdl->addComplexType(
   'TextResp', 'complexType', 'struct', 'all', '',
   array(
      'status' => array('name' => 'status', 'type' => 'xsd:string'),
      'message' => array('name' => 'message', 'type' => 'xsd:string')
   )
);

$server->register('sms_get_exten', array('InfoReq' => 'tns:InfoReq'),	// Define the ins and outs for the "sms_get_exten" service
                  array('InfoResp' => 'tns:InfoResp'), 
                  $namespace,
                  $namespace . '#sms_get_exten',
                  'rpc',
                  'encoded',
                  'get extension'
		   );

$server->register('sms_send', array('TextSend' => 'tns:TextSend'),		// Define the ins and outs for the "sms_send" service
                  array('TextResp' => 'tns:TextResp'), 
                  $namespace,
                  $namespace . '#sms_send',
                  'rpc',
                  'encoded',
                  'sms send'
		   );

function sms_get_exten($userReq) {  												// Again. just for test.  Have fun!
   log_print_text("ms_get_extension");
   $extension = $userReq['extension'];
   log_print_text($extension);
   $result_item = array("status"=>"FAIL");
   
   if (!$extension) {
   $msg = "\rNo name provided";
   log_print_text($msg);
      return new soap_fault('Client', '', 'Put your name!');
   }
   $result = "SIP:1003";
   $result_item = array("status"=>"SUCCESS", "message"=>$result);
   return $result_item;
}

function sms_send($userReq) {  														// Actual routine to send a text message outside a call using
   global $serverip;                                                    // MessageSend application via AMI
   log_print_text("sms_send");
   $extension = $userReq['extension'];
   $frm = $userReq['from'];
   $body = $userReq['body'];
	$from = '"' . $frm . '" ' .  '<sip:' . $frm . '@' . $serverip . '>';	// Form proper from; address
	$to = 'sip:' . $extension;                                           // Same to to: address

   log_print_text($to);
   log_print_text($from);
   log_print_text($body);
   $result_item = array("status"=>"FAIL"); 										// assume fail
   
	$base64body = '';																		// Not used for now
	$variable = '';

	$asm = new AGI_AsteriskManager();												// Set up for new connection
   if($asm->connect()) {                                                // Connect
	   log_print_text('Connect to Asterisk AMI');
   	$response = $asm->MessageSend($to, $from, $body, $base64body, $variable);	// Do it 
      log_var_dump($response);														// Log response
      $status = $response['Response'];
		$msg = $response['Message'];
	   $result_item = array("status"=>$status, "message"=>$msg);			// send back result	
	}
   return($result_item);
}

// Use the request to (try to) invoke the service
$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);
?>
