<?php
ini_set("error_reporting", "E_ERROR");
ini_set("soap.wsdl_cache_enabled","0");
ini_set('magic_quotes_gpc', 'off');
ini_set('register_globals', 'off');
ini_set('max_execution_time', 300);
ini_set("display_errors", 1);
date_default_timezone_set('America/Chicago');

function log_print_text($str) {
	global $logfilen;
	global $loglevel;
	global $new_script;
	if($loglevel >= 3 or !$new_script){$logfile = fopen($logfilen, 'a');} else {$logfile = fopen($logfilen, 'w');}
	fputs($logfile, "\r\n$str");
	fclose($logfile);
	$new_script = false;
}

function log_var_dump($v_array) {
	global $logfilen;
	global $loglevel;
	global $new_script;
	if($loglevel >= 3 or !$new_script){$logfile = fopen($logfilen, 'a');} else {$logfile = fopen($logfilen, 'w');}
   ob_start();
   var_dump($v_array);
   $out = ob_get_contents();
   ob_end_clean();
   fputs($logfile, "\r\n$out");
	fclose($logfile);   	
	$new_script = false;
}

function get_log_name() {
	global $_SERVER;
	global $logdir;
	$default = 'generic.php';
	if (isset($_SERVER['argv'])) {													// Start by assuming command line call.  First argument is program name
	   $args = $_SERVER['argv'];                                         	
	   if (isset($args[0])) {$arg0 = $args[0];} else {$arg0 = $default;}	// If argv is present but no name assign a generiv name.
	   if (isset($args[1])) {$arg1 = $args[1];} else {$arg1 = '1003';}	// default in case no argument is passed.  Maybe an error message is in order
	}
	else if (isset($_SERVER['REQUEST_URI'])) {									// If a server call, get the script name called.
		$arg0 = $_SERVER['REQUEST_URI'];
	}
	else {
		$arg0 = $default;																	// No other choice
	}	
	$tim1 = time();																		// Unix timestamp
	$date_log = date('mdY', $tim1);													// format for log file name
	$fn = basename($arg0, '.php');													// get base name of this file
	$logfilen = $logdir . strtolower($fn) . '-' . $date_log . '.log';		// form log filename with date
	return $logfilen;	
}

function fixhtml($text) {   															// Simple script to change HTML new lines to text new lines
   $trans = array("<br>" => "\r", "<br />" => "\r" );
   $text = strtr( $text, $trans);
   return $text;
}

$path = '/usr/share/pear/log4php';    												// Needed by PAMI libraries
set_include_path(get_include_path() . PATH_SEPARATOR . $path);				// in case it was not in include path
require_once('config.php');															// config has location for log files and loglevel
require_once('PAMI/Autoloader/Autoloader.php');  

$default_ip = '107.170.186.205'; 													// IP address needed for local test send
																								// Extract from $_SERVER variables if present
																								// otherwise use default IP address entered here.
if (isset($_SERVER['SERVER_ADDR'])) {$serverip = $_SERVER['SERVER_ADDR'];}  else {$serverip = $default_ip;}
$logfilen = get_log_name(); 															// Get log file name from this script name

$new_script = true;																		// First time so open a new file if not appending because of log level
$msg = '';
log_print_text($msg);
$msg = "Starting twilio_textin on server $serverip";
log_print_text($msg);
log_var_dump($_POST);																	// Just for debugging

PAMI\Autoloader\Autoloader::register(); 
$pamiClientOptions = array(   														// Set user details for Asterisk manager interface on this server
    'host' => '127.0.0.1',  
    'scheme' => 'tcp://',  
    'port' => 5038,  
    'username' => 'edhorton',  
    'secret' => 'bmw850i',  
    'connect_timeout' => 10000,  
    'read_timeout' => 10000  
);  
  
use PAMI\Client\Impl\ClientImpl as PamiClient;  
use PAMI\Message\Action\MessageSendAction;  
use PAMI\Message\Action\CommandAction;  
use PAMI\Message\Response\ResponseMessage;
use PAMI\Message\Message as RespMsg;
  
$pamiClient = new PamiClient($pamiClientOptions);   							// Setup new client
$pamiClient->open();                                                    // and open connection to Asterisk

																								// Field should be there, but set up defaults for testing from a browser
if(isset($_POST['From'])) {$from = $_POST['From'];} else {$from = '+13146609030';}
if(isset($_POST['To'])) {$to = $_POST['To'];} else { $to = '+16364893880';}
if(isset($_POST['Body'])) {$body = $_POST['Body'];} else { $body = 'This is the default message';}

$from = substr($from, 2); 																// May have to aduste for other than US numbers, but get rid of +1 in this case                                          
$to = substr($to, 2);    																// same as above
if (array_key_exists($to, $exten_map)) { 											// $exten_map is an associative array that maps incoming phone numbers to extensions                                         
	$exten = $exten_map[$to];
	$msg = "Incoming text to: $to routed to extension: $exten";  			// Get the extension if it exists
}
else {
	$exten = '1003';                                                  	// otherwise map some default extension of your choice
	$msg = "Incoming text to: $to routed to DEFAULT extension: $exten!";
}
log_print_text($msg);

$base64body = '';
$variable = '';
$external = false;																		// Assume extension is local, not on an external server
$msg = "Checking Dundi";
log_print_text($msg); 																	// in my case, the extension may be on a remote server mapped by DUNDI

$msg = "Calling CommandAction";  													// Do a DUNDI lookup.  This command assumes a standard DUNDI setup using keys
log_print_text($msg);                                                   // and IAX2 mapping as described in many Asterisk documents
$cmd = "dundi lookup " . $exten . "@priv"; 										// So, just form the command.
log_print_text($cmd);

$ami_response = $pamiClient->send(new CommandAction($cmd)); 				// Get response from AMI 
if($loglevel >= 4){																		// save response to a file for debug purposes
	ob_start();                                                          // Format of response is unusual, so this helped a lot
	var_dump($ami_response);
	$out = ob_get_contents();
	ob_end_clean();
	$testfilen = $logdir . 'dundi-ip.txt';
	$testfile = fopen($testfilen, 'w');
	fputs($testfile, $out);
	fclose($testfile);   	
}

$resp = $ami_response->getKeys();													// Because of response format, need to loop through all keys
foreach ($resp as $key => $value) {
	$k1 = trim(strtolower($key));														// and pull out only things of interest
	if (($k1 != 'response') and ($k1 != 'privilege') and ($k1 != 'actionid')){
		log_print_text($value);
		$t1 = stripos($key, 'returned no results');								// may be crude, but if not found by DUNDI to be external
		if ($t1 === false){                                              	// assume it is local
			$t1 = stripos($value, '(EXISTS)'); 										// if it is external, parse the returned address
			if ($t1 !== false) {
				$msg = "Extension found by Dundi";
				log_print_text($msg);
				$workf = substr($value, 0, $t1);
				$t2 = strripos($workf, '@');
				if ($t2 !== false) {
					$t2++;
					$addr = trim(substr($workf, $t2));
					$t1 = stripos($addr, $exten);
					$t1--;
					$add = substr($addr, 0, $t1);		
					log_print_text($add);
					$external = true;		
				}
			}
		}
	}
}

if($external){ 																			// send to remote asterisk server by connectinf to a Web Service on that machine.
	$webs_addr = 'http://' . $add . ':8080/sms/sms-ws.php';  				// unique to my install, the WEB server on all my Asterisk machines
	$wsdln = $webs_addr . '?wsdl'; 													// is responding to port 8080 rather than 80
	log_print_text($wsdln);																// added security, HTTPS, authentication may be needed or required!!
	try {
	   $client = new SoapClient($wsdln, array('trace' => 1));				// connect to the WEB Service using WSDL mode and enabling trace funcion
	   $webs_save = true;               
		$msg = "Soap Connection established.";   
		log_print_text($msg);
	   $errorf = false;
	}
	catch (SoapFault $fault) {  														// report a connection error
	   $faultc = $fault->faultcode;
	   $faults = $fault->faultstring;
	   $msg = "Soap Error #1: (faultcode: $faultc) (faultstring: $faults).";   
		log_print_text($msg);
	   $errorf = true;
	   $response = array('status' => 'FAIL', 'message' => 'Soap connection error!');
	   $respmsg = json_encode($response); 											// for future reporting.   
	}
	
	if (!$errorf){      																	// continue if server found
	   $soapcmd = 'sms_send';															// function to call
	   $soaparray = array(); 															// set up variables
	   $soaparray['extension'] = $exten;
	   $soaparray['from'] = $from;
	   $soaparray['body'] = $body;
	   try {
	      $response = ($client->$soapcmd($soaparray));							// send it 
	   }
	   catch (SoapFault $fault) { 													// report a WEB Service error
	      $faultc = $fault->faultcode;
	      $faults = $fault->faultstring;
	      $msg = "Soap Error #2: (faultcode: $faultc) (faultstring: $faults).";   
			log_print_text($msg);
	      $errorf = true;
		   $response = array('status' => 'FAIL', 'message' => 'Soap sms_get_extension function error!');
	   	$respmsg = json_encode($response);  
	   }
	}
	
	if (!$errorf){ 																		// If no error, continue logging SOAP transaaction if required by log level 
		if($loglevel >= 4){																// usefull if calling this routine from a WEB Browser for test
		   $v_request = $client->__getLastRequest(); 							// requires trace function be enabled
		   $v_request = str_replace('><',">\n<",$v_request);
		   echo "<hr><textarea rows='20' cols='250' style='background-color: #dddddd; color: blue;'>$v_request</textarea>";
		   $v_response = $client->__getLastResponse();
		   $v_response = str_replace('><',">\n<",$v_response);
		   echo "<hr><textarea rows='20' cols='250' style='background-color: #eeeeee; color: purple;'>$v_response</textarea>";
	   }
	   if (isset($response->status)) {$status = $response->status; } else { $status = 'FAIL';}	// if no status returned, assume failed
	   if (isset($response->message)) {$message = $response->message; } else { $message = '';} 	// extract returned message if present
	   log_print_text("Get Extension Status: $status");
	   if ($status == 'Success'){
	      $respmsg = json_encode($response);										// again not using this for now, but maybe for future Javascript apps.  
	   }
	   else {
	      $response = array('status' => 'FAIL');
	      $respmsg = json_encode($response);  
	   }
	}		
}

else { 																						// Got here because extension not found on any external servers
																								// could be beefed up to make sure it is on this local server
																								// by checking SIP peers, but I didn't need it in my situation 
	$msg = "Extension not found by Dundi so sending to local extension.";
	log_print_text($msg);
	$to = 'sip:' . $exten;                                               // Form proper arguments for MessageSendAction
	$fromf = '"' . $from . '" ' .  '<sip:' . $from . '@' . $serverip . '>';
	$msg = "Calling MessageSend with To: $to From: $fromf"; 					// NOTE!  I added MessageSendAction to the PAMI library
	log_print_text($msg);                                                // If not there in future releases, then I can provide changes
	$ami_response = $pamiClient->send(new MessageSendAction($to, $fromf, $body, $base64body, $variable));  
	$msg = $ami_response->getKey('message'); 										// This response is pretty much a normal response
	$response = array('status' => $msg);
	$respmsg = json_encode($response);  
	if($loglevel >= 4){                                                  // Again, for test
		$msg = '';
		log_print_text($msg);
		log_var_dump($man_response);
	}
}

log_print_text($respmsg); 																// Just additional logging for my benefit
if($loglevel >= 3){                                                  	// If appending logs, send out a blank line separator
	$msg = '';
	log_print_text($msg);
}

$pamiClient->close();																	// Done, so close manager connection  
?>